package Maccess_formatfce;

use strict;
use lib ("/home/web-maccess/www/maccess/bin","/home/web-maccess/www/lib");

my $pkg="Maccess_formatfce";

use My;
use MyXML;
use MySession;
use Maccess;
use Maccess_db;
use Maccess_locale;

#============== fce vracejici seznam formatovacich fci ===
sub index_formatfce {
   return (
      # univerzalni
      "bold",
      "style",
      "viewattach"
   );
}

#============== formatovaci fce univerzalni ==============

#- ztucneni hodnoty (ukazkova formatovaci fce)
sub bold {
   my ($pkg_p, $tO,$val,$ffce)=@_;
   if(!defined($tO)) {
      return [
      ];
   }
   if(!length($val)) {
      $val="\x{a0}";
   }
   my $xhtmlO=$tO->aT("xhtml");
   $xhtmlO->aT("b", {}, $val);
}

#- pridani stylu k hodnote (ukazkova formatovaci fce)
sub style {
   my ($pkg_p, $tO,$val,$ffce)=@_;
   if(!defined($tO)) {
      return [
         "style"
      ];
   }
   if(!length($val)) {
      $val="\x{a0}";
   }
   my $xhtmlO=$tO->aT("xhtml");
   $xhtmlO->aT("span", { style => $$ffce{style} }, $val);
}

#- zobrazuje hodnotu vlozenych dat primo jako obrazek a nebo jako link na obrazek
# Poznamka: schopnosti fce jsou omezeny dimenzi tabulky test.sessions (sloupec a_session je mediumblob), ktera je uzita k docasnemu ukladani priloh - maximalni velikost prilohy je tedy asi 16MB
sub viewattach {
   my ($pkg_p, $tO,$val,$ffce)=@_;
   if(!defined($tO)) {
      return [
         "link"
      ];
   }
   my $xhtmlO=$tO->aT("xhtml");
   if(!length($val)) {
      $xhtmlO->aT("span", {}, "\x{a0}");
   }
   else {
      # urci mimetyp hodnoty
      my $mimetype;
      if($val=~/^\x89PNG/) {
         $mimetype="image/png";
      }
      elsif($val=~/^GIF8[79]a/) {
         $mimetype="image/gif";
      }
      elsif($val=~/^(.{6}JFIF|\377\330\377\341..Exif\0)/) {
         $mimetype="image/jpeg";
      }
      else {
         $mimetype="application/octet-stream";
      }
      # ulozeni hodnoty do session
      my $attachid=MySession->write(undef, { mimetype => $mimetype, body => $val });
      my $attachsrc=Maccess->maccess_bin_path . "/formatfce_viewattach.phtml?attachid=" . encode_uri($attachid);
      if(!$$ffce{link} and $mimetype=~/^image\/(png|gif|jpeg)/) {
         $xhtmlO->aT("img", { src => $attachsrc }, $val);
      }
      else {
         $xhtmlO->aT("a", { href => $attachsrc }, translate("view attachment"));
      }
   }
}

return 1;

